Subject: RE: What exactly is LINDA

From: "Mattson, Timothy G" <[email-masked]>
Date: Thu, 30 Dec 1999 17:11:42 -0800

This is getting a bit off the topic of computational chemistry, so I will
try and keep it short.

In Gerald's last post, he questioned the scalability of Linda.  This is a
common misconception, so I just couldn't let it slip by.

The Linda implementation from Scientific Computing Associates (which is the
one used with Gaussian) scales very well with the number of nodes.   It uses
a compile time analysis that translates operations on a tuple space into
efficient message passing operations.  I have seen Linda jobs run on 128
nodes and there is no reason it can't go further (and actually, it probablly
has --- I just don't recall seeing it done).

The Computer science literature describes in detail how the Linda compiler
pulls off this trick.  I gave a reference to one paper in a previous post
that deals with this.  There is another paper that directly compares the
performance of Linda to message passing systems.  The reference to this
paper is:

     "The Linda alternative to message-passing systems"
     Parallel Computing, vol 20, pp. 633-655, 1994.
     Nicholas J. Carriero, David Gelernter, Timothy G. Mattson, and Andrew
H. Sherman

I won't bore the members of this list with the details, but if anyone wants
to talk to me about this further, feel free to send email.  

--Tim

> -----Original Message-----
> From:	Gerald Loeffler [SMTP:[email-masked]]
> Sent:	Wednesday, December 29, 1999 3:35 PM
> To:	[email-masked]
> Cc:	[email-masked]
> Subject:	CCL:What exactly is LINDA
> 
> Hi!
> 
> Linda is an implementation of the (by now almost classical) concept of
> tuple-space, which is quite similar to a message-board that is shared by
> otherwise completely independent processes. These processes can leave
> messages (data) at the message-board and collect messages (data) from
> the message-board. The tuple-space is thus a communication mechanism for
> distributed and/or parallel computing.
> 
> In principle you should be able to implement a tuple-space on top of
> different inter-process communication mechanisms like sockets, MPI, etc.
> I don't know what Linda itself uses - but it really doesn't matter
> because you are shielded from this.
> 
> Hoping that I'm not being unfair, I'd say that any concept (like that of
> a shared message-board) that uses a single, shared resource doesn't
> scale well with the number of processes trying to access this shared
> resource. Hence I'd guess that you get a very intuitive programming
> model at the expense of limited scalability.
> 
> This whole idea quite recently came to new fame with a Java
> implementation (Jini / JavaSpaces).
> 
> 	cheers,
> 	gerald
> 
> [email-masked] wrote:
> > 
> > What (exactly) is LINDA? Is it (merely) a message-passing library
> > a la PVM or MPI with a user-interface simulating a virtual shared
> > memory? What are you really paying for if you buy LINDA?
> > 
> > LINDA is known to me only in the context of parallel GAUSSIAN, so what
> > is the advantage of LINDA over PVM or MPI or other portable and
> > more-or-less standardized message passing systems? -- Does the
> combination
> > GAUSSIN/LINDA beat alternative implementations (e.g. with PVM) in terms
> > of speed or ease-of-use?
> > 
> >
> ---------------------------+----------------------------------------------
> --
> > Christoph van Wullen       | Fon (University):  +49 234 32 26485
> > Theoretical Chemistry      | Fax (University):  +49 234 32 14109
> > Ruhr-Universitaet          | Fon/Fax (private): +49 234 33 22 75
> > D-44780 Bochum, Germany    | eMail:
> [email-masked]
> >
> ---------------------------+----------------------------------------------
> --
> > 
> 
> -- 
>  Gerald Loeffler - Daemonstration Software Consulting
>  WWW:   http://www.daemonstration.com
>  Email: [email-masked]
>  Phone: +43 676 3289588
>  Fax:   +43 676 3509846
>  Smail: Siebensterngasse 46/4/114, A-1070 Vienna, Austria
>  Keywords: OOA&D, Java, J2EE, EJB, ODBMS, RDBMS, XML, Corba, RMI,
>            DNA Chip Technology, Computational Biology
> 
> -= This is automatically added to each message by mailing script =-
> [email-masked] -- To Everybody    |   [email-masked] -- To
> Admins
> [email-masked] -- HELP CHEMISTRY or HELP SEARCH
> [email-masked] -- archive search    |    Gopher: gopher.ccl.net
> 70
> Ftp: ftp.ccl.net  |  WWW: http://www.ccl.net/chemistry/   | Jan:
> [email-masked]
> 
> 
> 
> 
>